Package org.eclipse.graphiti.features.impl

# Class AbstractUpdateFeature

java.lang.Object
org.eclipse.graphiti.features.impl.AbstractFeature
org.eclipse.graphiti.features.impl.AbstractUpdateFeature

All Implemented Interfaces:
  `IFeature`, `IFeatureProviderHolder`, `IUpdateFeature`, `IUpdate`, `IDescription`, `IName`

Direct Known Subclasses:
  `DefaultUpdateDiagramFeature`, `UpdateFeatureForPattern`, `UpdateNoBoFeature`

public abstract class AbstractUpdateFeature extends AbstractFeature implements IUpdateFeature
The Class AbstractUpdateFeature.

## Constructor Summary

Constructors
Constructor
Description
`AbstractUpdateFeature(IFeatureProvider fp)`
Create a new `AbstractUpdateFeature`.

## Method Summary

Modifier and Type
Method
Description
`final boolean`
`canExecute(IContext context)`
Decides if the current feature can execute with the given context.
`protected boolean`
`canUpdatePictogramElement(PictogramElement pe)`
Can update pictogram element.
`void`
`execute(IContext context)`
Executes the current feature with the given context.
`String`
`getDescription()`
Gets the description.
`String`
`getName()`
Gets the name.
`protected void`
`resizeShape(Shape shape)`
Resize shape.
`protected void`
`updatePictogramElement(PictogramElement pe)`
Updates the given pictogram element.
`protected IReason`
`updatePictogramElementNeeded(PictogramElement pe)`
Update pictogram element needed.

### Methods inherited from class org.eclipse.graphiti.features.impl.AbstractFeature

`addGraphicalRepresentation, canUndo, getAllBusinessObjectsForPictogramElement, getBusinessObjectForPictogramElement, getDiagram, getDiagramBehavior, getFeatureProvider, getProgressCallback, getUserDecision, hasDoneChanges, isAvailable, layoutPictogramElement, link, link, manageColor, manageColor, manageDefaultFont, manageFont, manageFont, setProgressCallback, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.eclipse.graphiti.features.IFeature

`canUndo, hasDoneChanges, isAvailable`

### Methods inherited from interface org.eclipse.graphiti.features.IFeatureProviderHolder

`getFeatureProvider`

### Methods inherited from interface org.eclipse.graphiti.func.IUpdate

`canUpdate, update, updateNeeded`

## Constructor Details

### AbstractUpdateFeature

public AbstractUpdateFeature(IFeatureProvider fp)
Create a new `AbstractUpdateFeature`.

Parameters:
  `fp` - the feature provider

## Method Details

### canExecute

public final boolean canExecute(IContext context)
Description copied from interface: `IFeature`
Decides if the current feature can execute with the given context.

Specified by:
  `canExecute` in interface `IFeature`
Parameters:
  `context` - this is the general input for this method
Returns:
  true if the feature can be executed, false if not
See Also:
  - `IContext`

### execute

public void execute(IContext context)
Description copied from interface: `IFeature`
Executes the current feature with the given context.

Specified by:
  `execute` in interface `IFeature`
Parameters:
  `context` - this is the general input for this method
See Also:
  - `IContext`

### canUpdatePictogramElement

protected boolean canUpdatePictogramElement(PictogramElement pe)
Can update pictogram element.

Parameters:
  `pe` - the pe
Returns:
  true, if successful

### updatePictogramElementNeeded

protected IReason updatePictogramElementNeeded(PictogramElement pe)
Update pictogram element needed.

Parameters:
  `pe` - the pe
Returns:
  the i reason

### updatePictogramElement

protected void updatePictogramElement(PictogramElement pe)
Description copied from class: `AbstractFeature`
Updates the given pictogram element. This implementation asks the feature provider for available update features and processes the first one.

Overrides:
  `updatePictogramElement` in class `AbstractFeature`
Parameters:
  `pe` - the pe

### resizeShape

protected void resizeShape(Shape shape)
Resize shape.

Parameters:
  `shape` - the shape

### getName

public String getName()
Description copied from interface: `IName`
Gets the name.

Specified by:
  `getName` in interface `IName`
Overrides:
  `getName` in class `AbstractFeature`
Returns:
  the name

### getDescription

public String getDescription()
Description copied from interface: `IDescription`
Gets the description.

Specified by:
  `getDescription` in interface `IDescription`
Overrides:
  `getDescription` in class `AbstractFeature`
Returns:
  the description